module Jisota
  ##
  # Part of the Script duck type
  #
  # Contains a list of Scripts and can execute them consectutive.
  # If one script fails, the following will not be executed and the combined
  # result of this script will also be failed (`false`)
  class CompositeScript
    attr_accessor :scripts

    def initialize
      @scripts = []
    end

    def execute(context)
      scripts.each do |inner|
        result = inner.execute(context)
        return false unless result
      end
      true
    end
  end
end
