require 'jisota'

Jisota.global_config do
  package :nginx_passenger do
    description "Install nginx with passenger module"
    param :config_file, required: true

    section "Prerequisites"
    run do
      gem_install :passenger
      apt "libcurl4-openssl-dev"
    end

    section "Install nginx with passenger"
    run { cmd 'sudo passenger-install-nginx-module --auto --auto-download --prefix=/opt/nginx' }
    verify { cmd 'which /opt/nginx/sbin/nginx' }

    section "Files"
    run do
      upload from: config_file, to: '/opt/nginx/conf/nginx.conf' do
        update { cmd "sudo service nginx restart" }
      end

      upload from: "package_files/nginx_passenger/nginx_service", to: "/etc/init.d/nginx" do
        create { cmd 'sudo update-rc.d nginx defaults 99' }
      end
    end

    section "Start nginx"
    run { cmd "sudo service nginx start" }
    verify { cmd "ps -C nginx" }
  end
end
