require 'jisota'

Jisota.global_config do
  package :ruby do
    description "Installs ruby from source"
    param :version, required: true
    param :tmp_dir, default: "~/tmp"

    run do
      minor_version = version.match(/\d+\.\d+/)[0]

      apt *%w(libffi-dev libssl-dev zlib1g-dev libreadline-dev build-essential)
      cmd %Q{
        mkdir -p #{tmp_dir} &&
        cd #{tmp_dir} &&
        wget --continue --no-verbose http://cache.ruby-lang.org/pub/ruby/#{minor_version}/ruby-#{version}.tar.gz &&
        tar -zxvf ruby-#{version}.tar.gz &&
        cd ruby-#{version} &&
        ./configure &&
        make &&
        sudo make install
      }
    end
    verify do
      cmd "ruby -v | grep #{version}"
    end

    section "Install bundler"
    run { gem_install :bundler }
  end
end
