module Jisota
  ##
  # A package param
  #
  # Options:
  #
  # [default] Provide a default value for the param
  # [required] If true, an error is raised unless the param has a value
  # [splat] Will get remaining unnamed arguments
  class Param
    attr_reader :name, :options

    def initialize(name, options = {})
      @name = name
      @options = options
    end

    def default?
      options.has_key?(:default)
    end

    def default
      options[:default]
    end

    def required?
      !!options[:required]
    end

    def splat?
      !!options[:splat]
    end
  end
end
