module Jisota
  class ScriptContext
    attr_accessor :ssh_session, :logger, :params, :packages

    def initialize(options = {})
      @ssh_session = options.fetch(:ssh_session) { nil }
      @logger      = options.fetch(:logger) { NilOutput.new }
      @params      = options.fetch(:params) { Hash.new }
      @packages    = options.fetch(:packages) { Collection.new }
    end

    def command(cmd)
      ssh_session.command(cmd, logger)
    end

    def param_scope(scope_params)
      old_params = params
      self.params = scope_params
      result = yield if block_given?
      self.params = old_params
      result
    end
  end
end
